; PWM tpegysgvezrls modellvasthoz, a menetirnyvltsi lehetsg
; kitltsi tnyezhz ktsvel, 1.1. vltozat
; Knig Imre, 2014.
; Ez a program a Rditechnika folyiratban megjelen azonos trgy 
; cikkhez kszlt, szemlltet cllal. Br kiterjedt teszten ment
; keresztl, a szerz nem vllal rte felelssget, mindenki sajt
; felelssgre hasznlhatja. 

	list p=12f683
	list r=dec
	#include <p12f683.inc>
	#include <prlx.inc>
	#include <m4mac.inc>
	__config _INTOSCIO & _WDT_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _IESO_OFF & _FCMEN_OFF

; A program nhny tulajdonsgt ebben a blokkban lehet megadni:

; Az els kt adat a 0 s a teljes PWM kitlts kztti maximlis
; idtartamot hatrozza meg, "gyors" gyorsuls, "lass" lassuls esetn,
; feltve, hogy a sebessg potenciomtert ennl rvidebb id alatt 
; juttatjuk egyik vghelyzetbl a msikba. 
; 0: kb. 512 s, 1: kb. 257 s, 2: kb. 129,5 s, 3: kb.66,5 s a potmter
; szls llsban. A minimlis idtartam 2s. Az id a gyorsuls ill.
; lassuls potenciomter llsval linerisan vltozik.
; "gyors" s "lass" lehet klnbz. 
; A program a 4, 5, 6, 7 rtket is elfogadja egyre rvidl maximlis
; idkkel, aztn 7 felett a megadott szm 8-as maradkt hasznlja,
; vagyis minden kerek 8-nl jrakezdi a 0-7 tartomnyt.	
gyors	equ	4	; flperces vltozat
lass	equ	4	; flperces vltozat
; Ezek a paramterek a PWM frekvencit nem befolysoljk.

; A kvetkez kt adat az oszcilltor frekvencijt s az A/D ra 
; leosztst hatrozza meg, vltoztatni nem rdemes:
oscini	equ	0x40	; 1 MHz
ansini	equ	0x3b	; sajt rajel, an 1, 2, 4 hasznlhat

; Ez az adat az indul PWM kszbrtk 1/250 (0,4%)egysgben kifejezve:
smin	equ	50	; (20% kitlts), mozdonyhoz igazthat
; Ez pedig az irnyvltst megenged kszbrtk
smini	equ	10	; 4 % (<smin)

; Ezek az adatok a potenciomterek kiosztst hatrozzk meg:
; (selspd=clsebessg, selacc=gyorsuls, seldec=lassuls potmter
; vlaszt bjt, 1=AN1 (GPIO,0),5=AN2 (GPIO,1), 13=AN4 (GPIO,4).) 
selspd	equ	1	; adcon0 sebessg potmter vlaszt
selacc	equ	5	; adcon0 gyorsuls potmter vlaszt
seldec	equ	13	; adcon0 lassuls potmter vlaszt
; Ha rosszul jnne ki a NYK rajz, csereberlhetk.

; A program vltozi, ell 4 db 4 bjtos terlet		
	CBLOCK	0X20
	paca:4	; osztand, az oszts elvgzse utn maradk
	pacb:4	; oszt, az oszts sorn elromlik
	pacc:4	; hnyados
	speed:4	; gyjt, fels bjtjn kpzdik a kitlts rtke
	flags	; jelzbitek
	divcnt	; az oszts szmllja
	cseb	; clsebessg (1. potenciomter digitalizlt rtke)
	ENDC

; Bitdefincik	
#define	stad	adcon0,go	; go/done bit adcon0-ban (start A/D)
#define	mir	gpio,5		; menetirny kimenet
#define	gomb	gpio,3		; nyomgomb bemenet
#define	mehet	flags,0		; megszakts-fprogram szinkronbit
#define	le	flags,1		; vltozs irnya (lassts=1)
#define	tog	flags,2		; eljegyzett menetirnyvlts

; Program kezdete	
	org	0
	goto	main

; Megszakts	
; Ilyen megszaktst ltalban nem lehet rni, de kivtelesen semmit
; sem kell menteni, mert garantltan semmi kritikusat sem runk fell
; a kt bitmanipull utastssal:	
	org	4
	bsf	mehet		; szinkronbit =1
	bcf	pir1,tmr2if	; megszaktskrs trlve
	retfie			; visszatrs, nincs mit helyrelltani

; Fprogram
main
	clrf	gpio		; a port belltst j elre elintzni
	bsf	status,rp0	; bank1 sfr-ek lltsa kvetkezik
	movlw	ansini
	movwf	ansel		; an1, an2, an4, fosc/4
	bcf	option_reg,t0cs	; ne akarjon a pwm kimenetrl mkdni
	movlw	0x1b
	movwf	trisio		; gp2 s gp5 kimenet
	movlw	oscini
	movwf	osccon		; 2 MHz-re osztott bels oszcilltor
	bsf	pie1,tmr2ie	; erre a megszaktsra szksg lesz
	movlw	249		; PWM felbonts 250 (x4) egysg
	movwf	pr2
	bcf	status,rp0	; bank0 jn
	movlw	7
	movwf	cmcon0		; kompartor teljesen kikapcsolva
	clrf	ccpr1l		; kezdeti PWM kitlts 0
	movlw	6
	movwf	t2con		; t2 eloszt 16, t2 indul
	movlw	0x0c
	movwf	ccp1con		; ccp1 PWM zemmd, magas aktv
	clrf	flags		; trlsek
	clrf	speed		; speed=0
	clrf	speed+1
	clrf	speed+2
	clrf	speed+3		; mind a 4 bjton
	bsf	intcon,peie	; megszakts engedlyezs
	bsf	intcon,gie	; kt lpsben
	
; Fhurok	
mlp
	jnb	mehet,mlp	; vrakozs szinkronbitre
	bcf	mehet		; szinkronbit trlse
	movlw	selspd		; sebessg potenciomter
	movwf	adcon0		; kivlasztsa
	nop			; akvizcis id
	nop
	bsf	stad		; a/d konverzi indul
alp1
	jb	stad,alp1	; vrakozs konverzi vgre
	movf	adresh,w
	movwf	cseb		; eredmny elhelyezse cseb-ben
	cjbel	cseb,250,vizsg
	movl	cseb,250
	
; vizsglat: ha a kitlts egyenl a clrtkkel, elg a gombbal
; foglalkozni, ha nem, akkor a vltozs irnya az els krds
vizsg	
	cje	ccpr1l,cseb,gombbe
	bcf	le		; alaprtelmezs: nvelni kell
	csb	ccpr1l,cseb
	bsf	le		; ha mgis cskkenteni kell, le = 1,
	cjael	speed,smin,skind ; ha speed>smin, nincs vizsglat
	jb	le,lemin	; a le kln g
	cjbel	cseb,smin,lemin	; ha cseb<smin, mimin jn
	movl	speed,smin	; speed=smin (holtzna cskkentse)
	goto	tedd
lemin
	cjael	cseb,smin,skind
	clrf	speed
	goto	tedd
skind	
	movlw	selacc		; a gyorsuls 
	snb	le		; vagy ha az kell,
	movlw	seldec		; a lassuls poti beolvassa
	movwf	adcon0
	nop
	nop
	bsf	stad
alp2
	jb	stad,alp2
	comf	adresh,w	; rgtn a komplemenst olvassa 
	movwf	pacb		; pacb fels bjtjra		 

; a specilis oszts elksztse
	clrf	pacb+1		; a tbbi hrmat trljk
	clrf	pacb+2
	clrf	pacb+3
	movlw	1<<(gyors%8)	; a minimlis idt hatrozza meg
	snb	le
	movlw	1<<(lass%8)	; (lass%8) a lass/8 egsz oszts maradka
	addwf	pacb,f		; a legkisebb oszt(k) eltntetsvel.
				; Ez az sszeads tervezetten tlcsordulhat,
				; a tlcsordul bitet is felhasznljuk!
	rrf	pacb,f		; 1 bit jobbra, felveszi a carry-t is
	rrf	pacb+1,f	; a tbbi bjtot mr nem kell lptetni
; a specilis oszts tlti az osztandt, s gondoskodik az eredmny 
; nagysgrendjrl
	call	div4s
	rlc4	pacc	; balra tols a felezett PWM frekvencia miatt
; a kapott hnyadost eljelhelyesen kell majd a 4 bjtos speed-hez adni.
; itt lesz negatv a hnyados, ha le=1:
	snb	le
	call	neg_c4
; aztn mr mindkt vltozatra j a ngybjtos sszeads:
	add4u	speed,pacc,0
; egy kis vdekezs 
	jb	le,skfel
	movf	ccpr1l,w
	snc
	movwf	speed	; felfel akkor van baj, ha van tvitel
	cjbe	speed,cseb,tedd	; nvelje, ha kell
	mov	speed,cseb
	goto	tedd	; gombkezelsre, ha nem kell nvelni
skfel
	sc
	clrf	speed	;lefel akkor van baj, ha nincs tvitel
	cjae	speed,cseb,tedd	; cskkentse, ha kell
	mov	speed,cseb
	goto	tedd
; gombkezels
gombbe
	cjbl	ccpr1l,smini,irany	; elg kis kitltsnl ugrik
	bcf	tog	; tl nagy kitlts: eljegyzett vlts trlse	
	goto	mlp	; s kihagyja a vltst eredmnyez rszt
irany
	sb	gomb
	bsf	tog	; ha nyomva, eljegyzs
	jnb	gomb,mlp
	jnb	tog,mlp
	bcf	tog	; ha nem nyomva s volt eljegyzs: trli
	movlw	0x20	; az eljegyzst s tvltja
	xorwf	gpio,f	; a relkimenetet
	goto	mlp
; ccpr1l frisstse
tedd
	movf	speed,w	; speed fels bjtja
	movwf	ccpr1l	; ccpr1l-be rdik,
	goto	gombbe	; utna gombkezels		

; Szubrutinok
; specilis oszt szubrutin		
div4s
	movl	divcnt,-16	; -32 helyett, magyarzat a cikkben
	clrf	pacc		; az eredmny helyt ki kell
	clrf	pacc+1
	clrf	pacc+2
	clrf	pacc+3		; takartani
	movlw	0x80		; elhelyezzk az egyetlen
	movwf	paca
	clrf	paca+1
	clrf	paca+2
	clrf	paca+3		; lehetsges osztandt
d4spos
	btfsc	pacb,7		; az osztt legfels rtkes bitjnek
	goto	d4slp
	rlc4	pacb		; tkzsig balra toljuk
	incfsz	divcnt,f
	goto	d4spos
	return			; ha nulla az oszt, visszatr
d4slp
	decf	divcnt,f	; kivons elvgezhet?
	movf	pacb,w
	subwf	paca,w
	jnz	d4snck
	movf	pacb+1,w
	subwf	paca+1,w
	jnz	d4snck
	movf	pacb+2,w
	subwf	paca+2,w
	jnz	d4snck
	movf	pacb+3,w
	subwf	paca+3,w
d4snck
	jnc	d4snogo		; ha nincs carry, akkor nem, de
	sub4u	paca,pacb,0	; ha van carry, el kell vgezni
	bsf	status,c	; s akkor 1-et kell belptetni
d4snogo			; ha ugrssal jtt ide, akkor c=0 lp be
	rlf	pacc+3,f	; a ngybjtos pacc alja fell
	rlf	pacc+2,f
	rlf	pacc+1,f
	rlf	pacc,f
	rrc4	pacb		; pacb 4 bjtja 1 bittel jobbra lp
	jb	le,d4sle	; lasstsnl ms lehet a dinamika
	cjnel	divcnt,-(gyors%8+33),d4slp	; bitszmll
	return	; visszatr az elrt szm osztsi lps utn
d4sle
	cjnel	divcnt,-(lass%8+33),d4slp 	; bitszmll
	return	; visszatr az elrt szm osztsi lps utn

; (aritmetikai) komplementl szubrutin (hogy ne kelljen sszeads 
; s kivons kzl vlasztani "speed" mdostsnl): 		
neg_c4
	comf	pacc,f
	comf	pacc+1,f
	comf	pacc+2,f
	comf	pacc+3,f	; eddig logikai komplementls,
	incf	pacc+3,f	; ettl a +1-tl lesz aritmetikai
	sz			; cipeljk az esetleges tvitelt
	return
	incf	pacc+2,f
	sz
	return
	incf	pacc+1,f
	sz
	return
	incf	pacc,f		; ha kell, akr eddig is,
	return			; de pacc esetleges tlcsordulsnak vizsglata
				; mr a hv programra tartozik		
	end
